3 # SPDX-License-Identifier: GPL-2.0-only
5 # Copyright (C) 2019 Philippe Proulx <pproulx@efficios.com>
8 # This test validates that a `src.ctf.lttng-live` component successfully does
9 # various tasks that a `src.ctf.lttng-live` component is expected to do, like
10 # listing tracing sessions and receiving live traces / producing the expected
13 # A mock LTTng live server is used to feed data to the component.
17 if [ -n "${BT_TESTS_SRCDIR:-}" ]; then
18 UTILSSH
="$BT_TESTS_SRCDIR/utils/utils.sh"
20 UTILSSH
="$(dirname "$0")/../../utils/utils.sh"
23 # shellcheck source=../../utils/utils.sh
28 # Disable trap for SIGTERM since the following kill to the
29 # pidgroup will be SIGTERM. Otherwise it loops.
30 # The '-' before the pid number ($$) indicates 'kill' to signal the
31 # whole process group.
32 trap - SIGTERM
&& kill -- -$$
35 # Ensure that background child jobs are killed on SIGINT/SIGTERM
36 trap cleanup SIGINT SIGTERM
38 this_dir_relative
="plugins/src.ctf.lttng-live"
39 test_data_dir
="$BT_TESTS_DATADIR/$this_dir_relative"
40 trace_dir
="$BT_CTF_TRACES_PATH"
42 if [ "$BT_TESTS_OS_TYPE" = "mingw" ]; then
43 # Same as the above, but in Windows form (C:\foo\bar) instead of Unix form
45 trace_dir_native
=$
(cygpath
-w "${trace_dir}")
47 trace_dir_native
="${trace_dir}"
52 local retcode_file
="$2"
54 local server_args
=("$@")
56 local server_script
="$test_data_dir/lttng_live_server.py"
59 diag
"$BT_TESTS_PYTHON_BIN $server_script ${server_args[*]}"
60 run_python
"$BT_TESTS_PYTHON_BIN" "$server_script" "${server_args[@]}" 1>&2 &
65 # wait for server to exit
68 # write return code to file
69 echo $?
> "$retcode_file"
72 kill_lttng_live_server
() {
75 if [ ! -s "$pid_file" ]; then
79 kill -9 "$(cat "$pid_file")"
82 get_cli_output_with_lttng_live_server
() {
83 local cli_args_template
="$1"
84 local cli_stdout_file
="$2"
85 local cli_stderr_file
="$3"
87 local trace_path_prefix
="$5"
89 local server_args
=("$@")
96 local server_retcode_file
98 server_args
+=(--port-file "$port_file" --trace-path-prefix "$trace_path_prefix")
99 server_pid_file
="$(mktemp -t test-live-server-pid.XXXXXX)"
100 server_retcode_file
="$(mktemp -t test-live-server-ret.XXXXX)"
102 diag
"Starting LTTng live server mockup"
104 # This starts the server, which eventually writes its listening
105 # port number to the `$port_file` file. The lttng_live_server()
106 # function itself writes the server's PID to the
107 # `$server_pid_file` file. When the server exits,
108 # lttng_live_server() writes its return code to the
109 # `$server_retcode_file` file.
110 lttng_live_server
"$server_pid_file" "$server_retcode_file" "${server_args[@]}" &
114 while [ ! -s "$port_file" ]; do
117 # Timeout of 30 seconds
118 if [ "$i" -eq "300" ]; then
120 kill_lttng_live_server
"$server_pid_file"
122 rm -f "$server_pid_file"
123 rm -f "$server_retcode_file"
130 port
=$
(<"$port_file")
132 diag
"LTTng live port is $port"
134 cli_args
=${cli_args_template//@PORT@/$port}
136 # Split argument string by spaces into an array.
137 IFS
=' ' read -ra cli_args
<<< "$cli_args"
139 if ! bt_cli
"$cli_stdout_file" "$cli_stderr_file" "${cli_args[@]}"; then
140 # CLI failed: cancel everything else
141 kill_lttng_live_server
"$server_pid_file"
143 rm -f "$server_pid_file"
144 rm -f "$server_retcode_file"
148 # get server's return code
150 while [ ! -s "$server_retcode_file" ]; do
153 # Timeout of 30 seconds
154 if [ "$i" -eq "300" ]; then
156 kill_lttng_live_server
"$server_pid_file"
158 rm -f "$server_pid_file"
159 rm -f "$server_retcode_file"
168 ret
=$
(<"$server_retcode_file")
170 rm -f "$server_pid_file"
171 rm -f "$server_retcode_file"
177 local cli_args_template
="$2"
178 local expected_stdout
="$3"
179 local expected_stderr
="$4"
180 local trace_path_prefix
="$5"
182 local server_args
=("$@")
189 cli_stderr
="$(mktemp -t test-live-stderr.XXXXXX)"
190 cli_stdout
="$(mktemp -t test-live-stdout.XXXXXX)"
191 port_file
="$(mktemp -t test-live-server-port.XXXXXX)"
193 get_cli_output_with_lttng_live_server
"$cli_args_template" "$cli_stdout" \
194 "$cli_stderr" "$port_file" "$trace_path_prefix" "${server_args[@]}"
195 port
=$
(<"$port_file")
197 bt_diff
"$expected_stdout" "$cli_stdout"
198 ok $?
"$test_text - stdout"
199 bt_diff
"$expected_stderr" "$cli_stderr"
200 ok $?
"$test_text - stderr"
207 test_list_sessions
() {
208 # Test the basic listing of sessions.
209 # Ensure that a multi-domain trace is seen as a single session.
210 # run_test() is not used here because the port is needed to craft the
215 local tmp_stdout_expected
216 local template_expected
218 local test_text
="CLI prints the expected session list"
219 local cli_args_template
="-i lttng-live net://localhost:@PORT@"
220 local server_args
=("$test_data_dir/list-sessions.json")
222 template_expected
=$
(<"$test_data_dir/cli-list-sessions.expect")
223 cli_stderr
="$(mktemp -t test-live-list-sessions-stderr.XXXXXX)"
224 cli_stdout
="$(mktemp -t test-live-list-sessions-stdout.XXXXXX)"
225 port_file
="$(mktemp -t test-live-list-sessions-server-port.XXXXXX)"
226 tmp_stdout_expected
="$(mktemp -t test-live-list-sessions-stdout-expected.XXXXXX)"
228 get_cli_output_with_lttng_live_server
"$cli_args_template" "$cli_stdout" \
229 "$cli_stderr" "$port_file" "$trace_dir_native" "${server_args[@]}"
230 port
=$
(<"$port_file")
232 # Craft the expected output. This is necessary since the port number
233 # (random) of a "relayd" is present in the output.
234 template_expected
=${template_expected//@PORT@/$port}
236 echo "$template_expected" > "$tmp_stdout_expected"
238 bt_diff
"$tmp_stdout_expected" "$cli_stdout"
239 ok $?
"$test_text - stdout"
240 bt_diff
"/dev/null" "$cli_stderr"
241 ok $?
"$test_text - stderr"
246 rm -f "$tmp_stdout_expected"
250 # Attach and consume data from a multi packets ust session with no
252 local test_text
="CLI attach and fetch from single-domains session - no discarded events"
253 local cli_args_template
="-i lttng-live net://localhost:@PORT@/host/hostname/trace-with-index -c sink.text.details"
254 local server_args
=("$test_data_dir/base.json")
255 local expected_stdout
="${test_data_dir}/cli-base.expect"
256 local expected_stderr
="/dev/null"
258 run_test
"$test_text" "$cli_args_template" "$expected_stdout" \
259 "$expected_stderr" "$trace_dir_native" "${server_args[@]}"
262 test_multi_domains
() {
263 # Attach and consume data from a multi-domains session with discarded
265 local test_text
="CLI attach and fetch from multi-domains session - discarded events"
266 local cli_args_template
="-i lttng-live net://localhost:@PORT@/host/hostname/multi-domains -c sink.text.details"
267 local server_args
=("${test_data_dir}/multi-domains.json")
268 local expected_stdout
="$test_data_dir/cli-multi-domains.expect"
269 local expected_stderr
="/dev/null"
271 run_test
"$test_text" "$cli_args_template" "$expected_stdout" \
272 "$expected_stderr" "$trace_dir_native" "${server_args[@]}"
275 test_rate_limited
() {
276 # Attach and consume data from a multi packets ust session with no
277 # discarded events. Enforce a server side limit on the stream data
278 # requests size. Ensure that babeltrace respect the returned size and that
279 # many requests per packet works as expected.
280 # The packet size of the test trace is 4k. Limit requests to 1k.
281 local test_text
="CLI many requests per packet"
282 local cli_args_template
="-i lttng-live net://localhost:@PORT@/host/hostname/trace-with-index -c sink.text.details"
283 local server_args
=(--max-query-data-response-size 1024 "$test_data_dir/rate-limited.json")
284 local expected_stdout
="${test_data_dir}/cli-base.expect"
285 local expected_stderr
="/dev/null"
287 run_test
"$test_text" "$cli_args_template" "$expected_stdout" \
288 "$expected_stderr" "$trace_dir_native" "${server_args[@]}"
291 test_compare_to_ctf_fs
() {
292 # Compare the details text sink or ctf.fs and ctf.lttng-live to ensure
293 # that the trace is parsed the same way.
294 # Do the same with the session swapped on the relayd side. This validate
295 # that ordering is consistent between live and ctf fs.
296 local test_text
="CLI src.ctf.fs vs src.ctf.lttng-live"
297 local cli_args_template
="-i lttng-live net://localhost:@PORT@/host/hostname/multi-domains -c sink.text.details --params with-trace-name=false,with-stream-name=false"
298 local server_args
=("$test_data_dir/multi-domains.json")
299 local server_args_inverse
=("$test_data_dir/multi-domains-inverse.json")
300 local expected_stdout
301 local expected_stderr
303 expected_stdout
="$(mktemp -t test-live-compare-stdout-expected.XXXXXX)"
304 expected_stderr
="$(mktemp -t test-live-compare-stderr-expected.XXXXXX)"
306 bt_cli
"$expected_stdout" "$expected_stderr" "${trace_dir}/succeed/multi-domains" -c sink.text.details
--params "with-trace-name=false,with-stream-name=false"
307 bt_remove_cr
"${expected_stdout}"
308 bt_remove_cr
"${expected_stderr}"
309 run_test
"$test_text" "$cli_args_template" "$expected_stdout" \
310 "$expected_stderr" "$trace_dir_native" "${server_args[@]}"
311 diag
"Inverse session order from lttng-relayd"
312 run_test
"$test_text" "$cli_args_template" "$expected_stdout" \
313 "$expected_stderr" "$trace_dir_native" "${server_args_inverse[@]}"
315 rm -f "$expected_stdout"
316 rm -f "$expected_stderr"
319 test_inactivity_discarded_packet
() {
320 # Attach and consume data from a multi-packet trace with discarded
321 # packets and emit an inactivity beacon during the discarded packets
324 # | pkt seq:0 |<-------discarded packets------>| pkt seq:8 |
327 # This test was introduced to cover the following bug:
329 # When reading this type of trace locally, the CTF source is expected
330 # to introduce a "Discarded packets" message between packets 0 and 8.
331 # The timestamps of this message are [pkt0.end_ts, pkt8.begin_ts].
333 # In the context of a live source, the tracer could report an inactivity
334 # period during the interval of the "Discarded packets" message.
335 # Those messages eventually translate into a
336 # "Iterator inactivity" message with a timestamp set at the end of the
339 # If the tracer reports an inactivity period that ends at a point
340 # between pkt0 and pkt7 (resulting in an "Iterator inactivity" message),
341 # the live source could send a "Discarded packets" message that starts
342 # before the preceding "Iterator inactivity" message. This would break
343 # the monotonicity constraint of the graph.
344 local test_text
="CLI attach and fetch from single-domains session - inactivity discarded packet"
345 local cli_args_template
="-i lttng-live net://localhost:@PORT@/host/hostname/7-lost-between-2-with-index -c sink.text.details"
346 local server_args
=("$test_data_dir/inactivity-discarded-packet.json")
347 local expected_stdout
="$test_data_dir/inactivity-discarded-packet.expect"
348 local expected_stderr
="/dev/null"
350 run_test
"$test_text" "$cli_args_template" "$expected_stdout" \
351 "$expected_stderr" "$trace_dir_native" "${server_args[@]}"
354 test_split_metadata
() {
355 # Consume a metadata stream sent in two parts. This testcase tests the
356 # behaviour of Babeltrace when the tracing session was cleared (lttng
357 # clear) but the metadata is not yet available to the relay. In such
358 # cases, when asked for metadata, the relay will return the
359 # `LTTNG_VIEWER_METADATA_OK` status and a data length of 0. The viewer
360 # need to consider such case as a request to retry fetching metadata.
362 # This testcase emulates such behaviour by adding empty metadata
365 local test_text
="CLI attach and fetch from single-domain session - Receive metadata in two sections separated by a empty section"
366 local cli_args_template
="-i lttng-live net://localhost:@PORT@/host/hostname/split-metadata -c sink.text.details"
367 local server_args
=("$test_data_dir/split-metadata.json")
368 local expected_stdout
="${test_data_dir}/split-metadata.expect"
369 local expected_stderr
="/dev/null"
371 run_test
"$test_text" "$cli_args_template" "$expected_stdout" \
372 "$expected_stderr" "$trace_dir_native" "${server_args[@]}"
375 test_stored_values
() {
376 # Split metadata, where the new metadata requires additional stored
377 # value slots in CTF message iterators.
378 local test_text
="split metadata requiring additionnal stored values"
379 local cli_args_template
="-i lttng-live net://localhost:@PORT@/host/hostname/stored-values -c sink.text.details"
380 local server_args
=("$test_data_dir/stored-values.json")
381 local expected_stdout
="${test_data_dir}/stored-values.expect"
382 local expected_stderr
="/dev/null"
385 tmp_dir
=$
(mktemp
-d -t 'test-stored-value.XXXXXXX')
387 # Generate test trace.
388 gen_mctf_trace
"${trace_dir}/live/stored-values.mctf" "$tmp_dir/stored-values"
390 run_test
"$test_text" "$cli_args_template" "$expected_stdout" \
391 "$expected_stderr" "$tmp_dir" "${server_args[@]}"
402 test_compare_to_ctf_fs
403 test_inactivity_discarded_packet